#include "stdio.h"     
#include "unistd.h"    
#include "sys/ioctl.h"
#include "fcntl.h"     
#include "time.h"     
#include "asm/etraxgpio.h"

#define BUTTON_1  1<<2
#define BUTTON_2  1<<3
#define IO_SETGET_INPUT   0x12

int main(void) {
  int fdg;
  int iomask_g;
  unsigned char value = 0;

  if ((fdg = open("/dev/gpiog", O_RDWR))<0) {
    printf("ERRORE nell'apertura di /dev/gpiog\n");
    return 1;
  }
  
  iomask_g = BUTTON_1 | BUTTON_2;
  ioctl(fdg, _IO(ETRAXGPIO_IOCTYPE, IO_SETGET_INPUT),&iomask_g);
  
  while(1) {
  value=ioctl(fdg, _IO(ETRAXGPIO_IOCTYPE, IO_READBITS));
  if ((value&(BUTTON_2))==0) 
    printf("Pulante 1 premuto\n");
  if ((value&(BUTTON_1))==0) 
    printf("Pulante 2 premuto\n");
  }
}