
#include <stdio.h>     
#include <string.h>    
#include <unistd.h>    
#include <fcntl.h>     
#include <termios.h>   
#include <sys/types.h>
#include <sys/stat.h>
#include <signal.h>
#include <stdlib.h>

#define BAUDRATE B19200
#define DEVICE "/dev/ttyS3"



int main (int argc, char * argv[]) {
  int fd, res;
  struct termios oldtio,newtio;
  char buf[200];
  printf("Apertua Porta COM\n");
  fd = open(DEVICE, O_RDWR | O_NOCTTY);
  if (fd < 0 ) {
    printf("Device %s non pesente su questo sistema\n\n", DEVICE);
    exit(-1);
  }
  printf("Inizializzazione della comunicazione seriale\n");
  
  tcgetattr(fd,&oldtio); /* Salva i precedenti settaggi */
  
  bzero(&newtio, sizeof(newtio));
  newtio.c_cflag = BAUDRATE | CS8 | CLOCAL | CREAD;
  newtio.c_iflag = IGNPAR;
  newtio.c_oflag = 0;
  newtio.c_lflag = 0;
  newtio.c_cc[VTIME] = 0;
  newtio.c_cc[VMIN] = 1; 
  
  tcflush(fd, TCIFLUSH);
  tcsetattr(fd,TCSANOW,&newtio);
  //Inizializzazione device seriale terminata
  

  sprintf(buf, "Ciao sono la FOX sulla SX 18 :)\n\rScrivi ti ascolto (digita Q per terminare)\n\r");
  if (write(fd, buf, strlen(buf)) < 0) {
    printf("INVIO SULLA SERIALE FALLITO\n");
  } 
  
  while(1){
    res = read(fd,buf,sizeof(buf)); 
    buf[res]=0;

    if (write(fd, buf, strlen(buf)) < 0) {
      printf("INVIO SULLA SERIALE FALLITO\n");
    } 
    if (buf[0]=='Q') break;
  }
  
  
  printf("\nChiusura comunicazione seriale...\n");
  tcsetattr(fd,TCSANOW,&oldtio);
  printf("Arrivederci :)\n");
  close(fd);
  exit(0);
}